#!/bin/sh
# Composition {\`a} la carte du cours


                              # +---------------+
                              # |  Compilation  |
                              # +---------------+


compile() {

tex "\\def\\job{\\input fontes.cc $1}\\input cours"
tree -u cours.tr0 >cours.tr1
tex "\\def\\job{\\input fontes.cc $1}\\input cours"
dvips -Pwith-pk cours
psnup -2 <cours.ps >cours.ps2
gzip cours.ps
gzip cours.ps2
mv cours.ps.gz  $2.gz
mv cours.ps2.gz $2.gz2

}

                         # +------------------------+
                         # |  Conversion en 7 bits  |
                         # +------------------------+


do7bits() {

base=/tmp/make.$$
for i in `find`; do
  case $i in
   *~ | *.ans | *.dvi | *.log | *.ps* | *.bak | *.tgz | *.gz*) ;;
   ./accents.tex) ;;
   *) if [ -d $i ]; then
        mkdir -p $base/$i
      else
        echo $i
        sed  -e "s///" -e "s/$/
/" -f /usr/local/bin/ansi2tex.sed <$i >$base/$i
      fi
  esac
done
cd $base
sed -e 's/\\input accents/%\\input accents/' <carnot.mac >carnot.7bits
mv -f carnot.7bits carnot.mac
tar cvfz $OLDPWD/source.tgz *
cd $OLDPWD
rm -R $base

}
  

                               # +-------------+
                               # |  Nettoyage  |
                               # +-------------+

doclean() {

for i in . *; do rm  $i/*{~,.ans,.dvi,.log,.ps,.ps2,.gz,.gz2,.mat,.aux,.bak,.tgz}; done

}

                                # +-----------+
                                # |  Syntaxe  |
                                # +-----------+
 
dohelp() {

cat <<EOF
syntaxe : make.sh sup     -> cours de sup dans sup.ps et sup.ps2
          make.sh spe     -> cours de spe dans spe.ps et spe.ps2
          make.sh supspe  -> cours de sup et de spe dans supspe.ps et supspe.ps2
          make.sh lang    -> langages et automates
          make.sh all     -> sup + spe + probl{\`e}mes dans all.ps et all.ps2
          make.sh 7bits   -> conversion 7bits et archivage dans source.tgz
          make.sh clean   -> suppression des fichiers auxilliaires
EOF

}


                          # +-----------------------+
                          # |  programme principal  |
                          # +-----------------------+

case "$1" in
  sup)    compile '\jobsup'               $1 ;;
  spe)    compile '\jobspe'               $1 ;;
  supspe) compile '\jobup\jobspe'         $1 ;;
  lang)   compile '\INPUT{langages}'      $1 ;;
  all)    compile '\jobsup\jobspe\jobpb'  $1 ;;
  7bits)  do7bits ;;
  clean)  doclean ;;
  *)      dohelp ;;
esac
exit
